﻿function LockNotes_SlashCommandHandler( msg )
    LockNotes_Frame1:Show();
    nightfallCheckbox:SetChecked(nightfallEnabled);
    buffsCheckbox:SetChecked(enemyBuffsEnabled);
    targetOnlyCheckbox:SetChecked(targetAndFocusOnly);
    targetChangeUpdateCheckbox:SetChecked(targetChangeUpdate);
    if (targetOnlyCheckbox:GetChecked()) then
        targetChangeUpdateCheckbox:Enable();
    else
        targetChangeUpdateCheckbox:Disable();
    end
    missesCheckbox:SetChecked(resistsEnabled);
    meleeNoisesCheckBox:SetChecked(meleeNoisesEnabled);
    LockNotes_FearCOTDownCheckbox:SetChecked(LockNotes_FearCOTDown);
    LockNotes_SoulLinkAlertCheckbox:SetChecked(LockNotes_SoulLinkAlert);
    if (buffsCheckbox:GetChecked()) then
        targetOnlyCheckbox:Enable();
    else
        targetOnlyCheckbox:Disable();
    end
    eradicationButton:SetChecked(eradicationEnabled);
    LockNotes_DispelCheckbox:SetChecked(LNDispelTable["DispelEnabled"]);
    LockNotes_DispelCheckbox_OnClick();
    LockNotes_DispelVisualAlertCheckbox:SetChecked(LNDispelTable["DispelVisualAlert"]);
    LockNotes_DispelChatlogCheckbox:SetChecked(LNDispelTable["DispelChatlog"]);
    LockNotes_DispelSayCheckbox:SetChecked(LNDispelTable["DispelSay"]);
    LockNotes_DispelPartyCheckbox:SetChecked(LNDispelTable["DispelParty"]);
    LockNotes_DispelRaidCheckBox:SetChecked(LNDispelTable["DispelRaid"]);
    LockNotes_DispelBattlegroundCheckbox:SetChecked(LNDispelTable["DispelBattleground"]);
    LockNotes_SpelllockCheckbox:SetChecked(LNSpelllockTable["SpelllockEnabled"]);
    LockNotes_SpelllockCheckbox_OnClick();
    LockNotes_SpelllockVisualAlertCheckbox:SetChecked(LNSpelllockTable["SpelllockVisualAlert"]);
    LockNotes_SpelllockChatlogCheckbox:SetChecked(LNSpelllockTable["SpelllockChatlog"]);
    LockNotes_SpelllockSayCheckbox:SetChecked(LNSpelllockTable["SpelllockSay"]);
    LockNotes_SpelllockPartyCheckbox:SetChecked(LNSpelllockTable["SpelllockParty"]);
    LockNotes_SpelllockRaidCheckBox:SetChecked(LNSpelllockTable["SpelllockRaid"]);
    LockNotes_SpelllockBattlegroundCheckbox:SetChecked(LNSpelllockTable["SpelllockBattleground"]);
    LockNotes_ErrorFilterCheckBox:SetChecked(LockNotes_ErrorFilter);
    LockNotes_IconsCheckBox:SetChecked(LockNotes_Icons);
    LockNotes_TremorTotemCheckBox:SetChecked(LockNotes_TremorTotem);
    LockNotes_DeathAnnounceCheckBox:SetChecked(LockNotes_DeathAnnounce);
    LockNotes_DeathAnnounceSoundsCheckBox:SetChecked(LockNotes_DeathAnnounceSounds);
    PlaySound("igMainMenuOpen");
end
----------------------------------------------------------------Button Functions----------------------------------------------------------------
function LockNotes_cancelButton_OnClick()   --------CANCEL BUTTON
    LockNotes_Frame1:Hide();
    PlaySound("igMainMenuClose");
end

function LockNotes_FrameReset_OnClick()
    LockNotes_TremorTotemFrame:Hide();
    LockNotes_TremorTotemFrame:EnableMouse(false);
    LockNotes_TremorTotemFrame:UnregisterAllEvents();
    LockNotes_TremorTotemFrame:SetUserPlaced(false);
    LockNotes_TremorTotemFrame:SetMovable(false);

    LockNotes_DispelSpellLockFrame:Hide();
    LockNotes_DispelSpellLockFrame:EnableMouse(false);
    LockNotes_DispelSpellLockFrame:UnregisterAllEvents();
    LockNotes_DispelSpellLockFrame:SetUserPlaced(false);
    LockNotes_DispelSpellLockFrame:SetMovable(false);

    LockNotes_MainDisplayFrame:Hide();
    LockNotes_MainDisplayFrame:EnableMouse(false);
    LockNotes_MainDisplayFrame:UnregisterAllEvents();
    LockNotes_MainDisplayFrame:SetUserPlaced(false);
    LockNotes_MainDisplayFrame:SetMovable(false);

    LockNotes_FearSeduceFrame:Hide();
    LockNotes_FearSeduceFrame:EnableMouse(false);
    LockNotes_FearSeduceFrame:UnregisterAllEvents();
    LockNotes_FearSeduceFrame:SetUserPlaced(false);
    LockNotes_FearSeduceFrame:SetMovable(false);

    LockNotes_MovingFrame:Hide();
    ReloadUI();
end

function LockNotes_FrameSet_OnClick()
    LockNotes_TremorTotemFrame:Hide();
    LockNotes_TremorTotemFrame:EnableMouse(false);
    LockNotes_TremorTotemFrame:UnregisterAllEvents();

    LockNotes_DispelSpellLockFrame:Hide();
    LockNotes_DispelSpellLockFrame:EnableMouse(false);
    LockNotes_DispelSpellLockFrame:UnregisterAllEvents();

    LockNotes_MainDisplayFrame:Hide();
    LockNotes_MainDisplayFrame:EnableMouse(false);
    LockNotes_MainDisplayFrame:UnregisterAllEvents();

    LockNotes_FearSeduceFrame:Hide();
    LockNotes_FearSeduceFrame:EnableMouse(false);
    LockNotes_FearSeduceFrame:UnregisterAllEvents();

    LockNotes_MovingFrame:Hide();
    PlaySound("igMainMenuClose");
end

function LockNotes_MoveFramesButton_OnClick()
    LockNotes_Frame1:Hide();

    LockNotes_TremorTotemFrame:SetMovable(true);
    LockNotes_TremorTotemFrame:Show();
    LockNotes_TremorTotemFrame:SetUserPlaced(true);
    LockNotes_TremorTotemFrame:EnableMouse(true);
    LockNotes_TremorTotemFrame:RegisterForDrag("LeftButton");
    LockNotes_TremorTotemFrame:SetScript("OnDragStart",LockNotes_TremorTotemFrame.StartMoving);
    LockNotes_TremorTotemFrame:SetScript("OnDragStop",LockNotes_TremorTotemFrame.StopMovingOrSizing);

    LockNotes_DispelSpellLockFrame:SetMovable(true);
    LockNotes_DispelSpellLockFrame:Show();
    LockNotes_DispelSpellLockFrame:SetUserPlaced(true);
    LockNotes_DispelSpellLockFrame:EnableMouse(true);
    LockNotes_DispelSpellLockFrame:RegisterForDrag("LeftButton");
    LockNotes_DispelSpellLockFrame:SetScript("OnDragStart",LockNotes_DispelSpellLockFrame.StartMoving);
    LockNotes_DispelSpellLockFrame:SetScript("OnDragStop",LockNotes_DispelSpellLockFrame.StopMovingOrSizing);

    LockNotes_MainDisplayFrame:SetMovable(true);
    LockNotes_MainDisplayFrame:Show();
    LockNotes_MainDisplayFrame:SetUserPlaced(true);
    LockNotes_MainDisplayFrame:EnableMouse(true);
    LockNotes_MainDisplayFrame:RegisterForDrag("LeftButton");
    LockNotes_MainDisplayFrame:SetScript("OnDragStart",LockNotes_MainDisplayFrame.StartMoving);
    LockNotes_MainDisplayFrame:SetScript("OnDragStop",LockNotes_MainDisplayFrame.StopMovingOrSizing);

    LockNotes_FearSeduceFrame:SetMovable(true);
    LockNotes_FearSeduceFrame:Show();
    LockNotes_FearSeduceFrame:SetUserPlaced(true);
    LockNotes_FearSeduceFrame:EnableMouse(true);
    LockNotes_FearSeduceFrame:RegisterForDrag("LeftButton");
    LockNotes_FearSeduceFrame:SetScript("OnDragStart",LockNotes_FearSeduceFrame.StartMoving);
    LockNotes_FearSeduceFrame:SetScript("OnDragStop",LockNotes_FearSeduceFrame.StopMovingOrSizing);

    LockNotes_MovingFrame:Show();
    PlaySound("igMainMenuOption");
end

function LockNotes_okButton_OnClick()   -------OK BUTTON
------------------------------------------------------check if checkboxes checked---------------------------
    nightfallEnabled = nightfallCheckbox:GetChecked();
    enemyBuffsEnabled = buffsCheckbox:GetChecked();
    LockNotes_ErrorFilter = LockNotes_ErrorFilterCheckBox:GetChecked();
    targetAndFocusOnly = targetOnlyCheckbox:GetChecked();
    if(enemyBuffsEnabled~=1) then
        targetAndFocusOnly = nil;
    end
    targetChangeUpdate = targetChangeUpdateCheckbox:GetChecked();
    if(targetAndFocusOnly==nil) then
        targetChangeUpdate = nil;
    end
    resistsEnabled = missesCheckbox:GetChecked();
    meleeNoisesEnabled = meleeNoisesCheckBox:GetChecked();
    eradicationEnabled = eradicationButton:GetChecked();
    if(LockNotes_DispelCheckbox:GetChecked()) then
        LNDispelTable["DispelEnabled"] = true;
    else
        LNDispelTable["DispelEnabled"] = false;
    end
    if(LNDispelTable["DispelEnabled"]) then
        if(LockNotes_DispelVisualAlertCheckbox:GetChecked()) then
            LNDispelTable["DispelVisualAlert"] = true;
        else
            LNDispelTable["DispelVisualAlert"] = false;
        end
        if(LockNotes_DispelChatlogCheckbox:GetChecked()) then
            LNDispelTable["DispelChatlog"] = true;
        else
            LNDispelTable["DispelChatlog"] = false;
        end
        if(LockNotes_DispelSayCheckbox:GetChecked()) then
            LNDispelTable["DispelSay"] = true;
        else
            LNDispelTable["DispelSay"] = false;
        end
        if(LockNotes_DispelPartyCheckbox:GetChecked()) then
            LNDispelTable["DispelParty"] = true;
        else
            LNDispelTable["DispelParty"] = false;
        end
        if(LockNotes_DispelRaidCheckBox:GetChecked()) then
            LNDispelTable["DispelRaid"] = true;
        else
            LNDispelTable["DispelRaid"] = false;
        end
        if(LockNotes_DispelBattlegroundCheckbox:GetChecked()) then
            LNDispelTable["DispelBattleground"] = true;
        else
            LNDispelTable["DispelBattleground"] = false;
        end
    else
        LNDispelTable["DispelVisualAlert"] = false;
        LNDispelTable["DispelChatlog"] = false;
        LNDispelTable["DispelSay"] = false;
        LNDispelTable["DispelParty"] = false;
        LNDispelTable["DispelRaid"] = false;
        LNDispelTable["DispelBattleground"] = false;
    end

    if(LockNotes_SpelllockCheckbox:GetChecked()) then
        LNSpelllockTable["SpelllockEnabled"] = true;
    else
        LNSpelllockTable["SpelllockEnabled"] = false;
    end
    if(LNSpelllockTable["SpelllockEnabled"]) then
        if(LockNotes_SpelllockVisualAlertCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockVisualAlert"] = true;
        else
            LNSpelllockTable["SpelllockVisualAlert"] = false;
        end
        if(LockNotes_SpelllockChatlogCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockChatlog"] = true;
        else
            LNSpelllockTable["SpelllockChatlog"] = false;
        end
        if(LockNotes_SpelllockSayCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockSay"] = true;
        else
            LNSpelllockTable["SpelllockSay"] = false;
        end
        if(LockNotes_SpelllockPartyCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockParty"] = true;
        else
            LNSpelllockTable["SpelllockParty"] = false;
        end
        if(LockNotes_SpelllockRaidCheckBox:GetChecked()) then
            LNSpelllockTable["SpelllockRaid"] = true;
        else
            LNSpelllockTable["SpelllockRaid"] = false;
        end
        if(LockNotes_SpelllockBattlegroundCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockBattleground"] = true;
        else
            LNSpelllockTable["SpelllockBattleground"] = false;
        end
    else
        LNSpelllockTable["SpelllockVisualAlert"] = false;
        LNSpelllockTable["SpelllockChatlog"] = false;
        LNSpelllockTable["SpelllockSay"] = false;
        LNSpelllockTable["SpelllockParty"] = false;
        LNSpelllockTable["SpelllockRaid"] = false;
        LNSpelllockTable["SpelllockBattleground"] = false;
    end

    if(LockNotes_SoulLinkAlertCheckbox:GetChecked()) then
        LockNotes_SoulLinkAlert = true;
    else
        LockNotes_SoulLinkAlert = false;
    end
    if(LockNotes_FearCOTDownCheckbox:GetChecked()) then
        LockNotes_FearCOTDown = true;
    else
        LockNotes_FearCOTDown = false;
    end
    if(LockNotes_IconsCheckBox:GetChecked()) then
        LockNotes_Icons = true;
    else
        LockNotes_Icons = false;
    end
    if(LockNotes_TremorTotemCheckBox:GetChecked()) then
        LockNotes_TremorTotem = true;
    else
        LockNotes_TremorTotem = false;
    end
    if(LockNotes_DeathAnnounceCheckBox:GetChecked()) then
        LockNotes_DeathAnnounce = true;
    else
        LockNotes_DeathAnnounce = false;
    end
    if(LockNotes_DeathAnnounceSoundsCheckBox:GetChecked() and LockNotes_DeathAnnounceSoundsCheckBox:IsEnabled())then
        LockNotes_DeathAnnounceSounds = true;
    else
        LockNotes_DeathAnnounceSounds = false;
    end
--------------------------------set nils to false for saved variable purposes
    if (not nightfallEnabled) then
        nightfallEnabled = false;
    end
    if (not enemyBuffsEnabled) then
        enemyBuffsEnabled = false;
    end
    if (not targetAndFocusOnly) then
        targetAndFocusOnly = false;
    end
    if (not targetChangeUpdate) then
        targetChangeUpdate = false;
    end
    if (not resistsEnabled) then
        resistsEnabled = false;
    end
    if (not meleeNoisesEnabled) then
        meleeNoisesEnabled = false;
    end
    if (not eradicationEnabled) then
        eradicationEnabled = false;
    end
    if (not LockNotes_ErrorFilter) then
        LockNotes_ErrorFilter = false;
    end
    LockNotes_Frame1:Hide();
    if(not targetChangeUpdate) then
        LockNotesFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED");
    else
        LockNotesFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:RegisterEvent("PLAYER_FOCUS_CHANGED");
    end
    if(LockNotes_Icons) then
        LockNotes_MainDisplayFrameTexture:Show();
        LockNotes_DispelSpellLockFrameTexture:Show();
    else
        LockNotes_MainDisplayFrameTexture:Hide();
        LockNotes_DispelSpellLockFrameTexture:Hide();
    end
    if(not LockNotes_SoulLinkAlert) then
        LockNotesFrame:UnregisterEvent("UNIT_PET");
        LockNotesFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
    else
        LockNotesFrame:RegisterEvent("UNIT_PET");
        LockNotesFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
    end
    PlaySound("igMainMenuClose");
end
-----------------------------------------------------------------------------CheckBox Clicks-------------------------------------------------------------
function targetOnlyCheckbox_OnClick()  ------TARGETONLYCHECKBOX CLICK
    if(targetOnlyCheckbox:GetChecked() and targetOnlyCheckbox:IsEnabled()) then
        targetChangeUpdateCheckbox:Enable();
    else
        targetChangeUpdateCheckbox:Disable();
    end
end

function LockNotes_DeathAnnounceCheckBox_OnClick()
    if(LockNotes_DeathAnnounceCheckBox:GetChecked())then
        LockNotes_DeathAnnounceSoundsCheckBox:Enable();
    else
        LockNotes_DeathAnnounceSoundsCheckBox:Disable();
    end
end

function buffsCheckbox_OnClick()     -------BUFFS CHECKBOX CLICK
    if (buffsCheckbox:GetChecked()) then -- disable target/focus only checkbox if buffs are turned off
        targetOnlyCheckbox:Enable();
		if(targetOnlyCheckbox:GetChecked()) then
			targetChangeUpdateCheckbox:Enable();
		end
    else
        targetOnlyCheckbox:Disable();
        targetChangeUpdateCheckbox:Disable();
    end
end

function LockNotes_DispelCheckbox_OnClick()
    if(LockNotes_DispelCheckbox:GetChecked()) then
        LockNotes_DispelVisualAlertCheckbox:Enable();
        LockNotes_DispelChatlogCheckbox:Enable();
        LockNotes_DispelSayCheckbox:Enable();
        LockNotes_DispelPartyCheckbox:Enable();
        LockNotes_DispelRaidCheckBox:Enable();
        LockNotes_DispelBattlegroundCheckbox:Enable();     
    else
        LockNotes_DispelVisualAlertCheckbox:Disable();
        LockNotes_DispelChatlogCheckbox:Disable();
        LockNotes_DispelSayCheckbox:Disable();
        LockNotes_DispelPartyCheckbox:Disable();
        LockNotes_DispelRaidCheckBox:Disable();
        LockNotes_DispelBattlegroundCheckbox:Disable();
    end
end

function LockNotes_SpelllockCheckbox_OnClick()
    if(LockNotes_SpelllockCheckbox:GetChecked()) then
        LockNotes_SpelllockVisualAlertCheckbox:Enable();
        LockNotes_SpelllockChatlogCheckbox:Enable();
        LockNotes_SpelllockSayCheckbox:Enable();
        LockNotes_SpelllockPartyCheckbox:Enable();
        LockNotes_SpelllockRaidCheckBox:Enable();
        LockNotes_SpelllockBattlegroundCheckbox:Enable();     
    else
        LockNotes_SpelllockVisualAlertCheckbox:Disable();
        LockNotes_SpelllockChatlogCheckbox:Disable();
        LockNotes_SpelllockSayCheckbox:Disable();
        LockNotes_SpelllockPartyCheckbox:Disable();
        LockNotes_SpelllockRaidCheckBox:Disable();
        LockNotes_SpelllockBattlegroundCheckbox:Disable();
    end
end
----------------------------------------------------------------On Load-------------------------------------------------------------------------
function LockNotes_OnLoad(this)
    this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    this:RegisterEvent("PLAYER_TARGET_CHANGED");
    this:RegisterEvent("PLAYER_FOCUS_CHANGED");
    this:RegisterEvent("ADDON_LOADED");
    this:RegisterEvent("UNIT_PET");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
    this:RegisterEvent("UNIT_FLAGS");
    MySpellReflected = 1;
    LockNotes_TremorTotemID = 0;
    LockNotes_PetChangeCount = -2;
    LNDispelTable={DispelEnabled = true, DispelVisualAlert = true, DispelChatlog = true, DispelSay = false, DispelParty = false, DispelRaid = false, DispelBattleground = false};
    LNSpelllockTable={SpelllockEnabled = true, SpelllockVisualAlert = true, SpelllockChatlog = true, SpelllockSay = false, SpelllockParty = false, SpelllockRaid = false, SpelllockBattleground = false};
------------------------------------initialize savedvariables on first startup
    nightfallEnabled=true;
    enemyBuffsEnabled=true;
    targetAndFocusOnly=true;
    targetChangeUpdate=true;
    resistsEnabled=true;
    meleeNoisesEnabled=true;
    eradicationEnabled=false;
    LockNotes_ErrorFilter=true;
    LockNotes_SoulLinkAlert=true;
    LockNotes_FearCOTDown=true;
    LockNotes_Icons=true;
    LockNotes_TremorTotem=false;
    LockNotes_DeathAnnounce = true;
    LockNotes_DeathAnnounceSounds = true;
---------------------------------end initialization of saved variables, begin slash commands
    SlashCmdList["LOCKNOTES"] = LockNotes_SlashCommandHandler; -- Add slash command handler to the list of slash commands
    SLASH_LOCKNOTES1 = "/locknotes"; -- Associate /locknotes with the slash command list entry for LOCKNOTES
    SLASH_LOCKNOTES2 = "/ln"; -- Associate /ln with the slash command list entry for LOCKNOTES
end

function LockNotes_ErrorsFrame_AddMessage(self, msg, ...) 
  if (LockNotes_ErrorFilter and (msg == "Spell is not ready yet.") or (string.find(msg,"Can't attack")) or (string.find(msg,"Can't do")) or (string.find(msg,"can't do")) or (msg == "You are unable to move") or (msg == "You must equip that item to use it.") or (msg == "Interrupted") or (msg == "Your target is dead") or (msg == "Invalid target") or (msg == "You are dead") or (msg == "You can't do that when you're dead.") or (msg == "You have no target.") or (msg == "There is nothing to attack.") or (msg == "Another action is in progress") or (msg == "You can't do that yet") or (msg == "You are stunned") or (msg == "Another action is in progress.") or (msg == "Item is not ready yet.") or (msg == "Ability is not ready yet.") or (msg == "You cannot attack that target.")) then 
    return;
  end 
  return self:LockNotes_Orig_AddMessage(msg, ...); 
end 
 
function LockNotes_HookErrorsFrame() 
   local ef = getglobal("UIErrorsFrame"); 
   ef.LockNotes_Orig_AddMessage = ef.AddMessage;
   ef.AddMessage = LockNotes_ErrorsFrame_AddMessage; 
end
------------------------------------------------------------Target and focus change------------------------------------------------
function LockNotes_OnEventTargetChange()
    if (UnitIsEnemy("player","target")) then
        local i = 1;
        local buffNOTNil = true;
        while (i <=40 and buffNOTNil) do local _,_,_,_,_,_,_,_,_,_,spellID=UnitBuff("target",i);   
            i=i+1;
            buffNOTNil = spellID;
            if ((spellID == 31224)    -- Cloak of Shadows
                or (spellID == 46924) -- Bladestorm
                or (spellID == 642)   -- Divine Shield
                or (spellID == 47585) -- Disperson
                or (spellID == 23920) -- Spell Reflect
                or (spellID == 48707) -- Anti Magic Shell
                or (spellID == 45438) -- IceBlock
                or (spellID == 19263) -- Deterrence
                or (spellID == 49039) -- LichBorne
                or (spellID == 18499) -- Berserker Rage
                or (spellID == 6346)  -- Fear Ward
                or (spellID == 1719)  -- Recklessness
                or (spellID == 96267)  -- Strength of Soul
                or (spellID == 8178) -- Grounding Totem
                or (spellID == 31821)) then -- Concentration Aura
                local spellName,_,_,_,_,_,_,_,_ = GetSpellInfo(spellID);
                if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
                end
                LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." up! (TAR)");
                LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0, 0);
                LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
                if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
			    elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) or (spellID == 46924) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
			    else
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
			    end
			    if (spellID == 23920) then
			        MySpellReflected = false;
			    end
            end    
        end
    end
end

function LockNotes_OnEventFocusChange()
    if (UnitIsEnemy("player","focus")) then
        local i = 1;
        local buffNOTNil = true;
        while (i <=40 and buffNOTNil) do local _,_,_,_,_,_,_,_,_,_,spellID=UnitBuff("focus",i);   
            i=i+1;
            buffNOTNil = spellID;
            if ((spellID == 31224)    -- Cloak of Shadows
                or (spellID == 46924) -- Bladestorm
                or (spellID == 642)   -- Divine Shield
                or (spellID == 47585) -- Disperson
                or (spellID == 23920) -- Spell Reflect
                or (spellID == 48707) -- Anti Magic Shell
                or (spellID == 45438) -- IceBlock
                or (spellID == 19263) -- Deterrence
                or (spellID == 49039) -- LichBorne
                or (spellID == 18499) -- Berserker Rage
                or (spellID == 6346)  -- Fear Ward
                or (spellID == 1719)  -- Recklessness
                or (spellID == 96267)  -- Strength of Soul
                or (spellID == 8178) -- Grounding Totem
                or (spellID == 31821)) then -- Concentration Aura
                local spellName,_,_,_,_,_,_,_,_ = GetSpellInfo(spellID);
                if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
                end
                LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." up! (foc)");
                LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0, 1);
                LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
                if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
			    elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) or (spellID == 46924) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
			    else
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
			    end
			    if (spellID == 23920) then
			        MySpellReflected = false;
			    end
            end    
        end
    end
end

function LockNotes_StripServer(text)
	local name, server = string.match(text, "(.-)%-(.*)$")
	if( not name and not server ) then
		return text
	end
	
	return name
end

function LockNotes_UnRegisterNonCheckedEvents()
    if(LockNotes_Icons) then
        LockNotes_DispelSpellLockFrameTexture:Show();
        LockNotes_MainDisplayFrameTexture:Show();
    else
        LockNotes_MainDisplayFrameTexture:Hide();
        LockNotes_DispelSpellLockFrameTexture:Hide();
    end
    if(not targetChangeUpdate) then
        LockNotesFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED");
    end
    if(not LockNotes_SoulLinkAlert) then
        LockNotesFrame:UnregisterEvent("UNIT_PET");
        LockNotesFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
    end
end

function LockNotes_EventHandler(self, event, ...)
    if(event=="COMBAT_LOG_EVENT_UNFILTERED") then
        LockNotes_CombatLogEvent(self, event, ...);
    elseif(event=="PLAYER_TARGET_CHANGED") then
        LockNotes_OnEventTargetChange();
    elseif(event=="PLAYER_FOCUS_CHANGED") then
        LockNotes_OnEventFocusChange();
    elseif(event=="ADDON_LOADED") then
        LockNotes_UnRegisterNonCheckedEvents();
    elseif(event=="UNIT_PET") then
        LockNotes_PetSummoned(...);
    elseif(event=="PLAYER_ENTERING_WORLD") then
        LockNotes_PetChangeCount = -3;
    end   
end

function LockNotes_PetSummoned(playerID)
    if(playerID == "player") then
        LockNotes_PetChangeCount = LockNotes_PetChangeCount + 1;
        if(IsFlying()) then
            LockNotes_PetChangeCount = 0;
        end
        if(LockNotes_PetChangeCount == 3) then
            local soulLinkFound = false;
            local i = 1;
            local buffNOTNil = 1;
            while (i <=40 and buffNOTNil) do local _,_,_,_,_,_,_,_,_,_,spellID=UnitBuff("pet",i);   
                i=i+1;
                buffNOTNil = spellID;
                if(spellID == 25228) then
                    soulLinkFound = true;
                end
            end
            if(not soulLinkFound) then
                if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
                end
                LockNotes_MainDisplayFrameFontString:SetText("SOUL LINK DOWN");
                LockNotes_MainDisplayFrameFontString:SetTextColor(1, 1, 1);
                LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(25228));
                UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
                PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\klaxon.mp3");
            end
        end
    end

end
local eventRegistered = {["SPELL_AURA_APPLIED"] = true, ["SPELL_AURA_REFRESH"] = true, ["SPELL_AURA_REMOVED"] = true, ["SPELL_CAST_SUCCESS"] = true, ["SPELL_MISSED"] = true, ["SPELL_DISPEL"] = true, ["SPELL_INTERRUPT"] = true, ["UNIT_DIED"] = true, ["SPELL_SUMMON"] = true, ["UNIT_DESTROYED"] = true};
function LockNotes_CombatLogEvent(self, event, timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, arg11, arg12, arg13)
if( not eventRegistered[eventType] ) then
    return
end
------------------------------------------------------------- Friendly Buffs --------------------------------
-- Shadow Trance/BackSlash/empowered imp and eradication/molten core/decimation
if (eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH") then
	if bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
        local spellHit = false;
        if (spellID == 17941) and nightfallEnabled then  -- nightfall proc
			LockNotes_MainDisplayFrameFontString:SetText("Shadow Bolt!");
            LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0, 1);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
            spellHit = true;
        elseif ((spellID == 34936) or (spellID == 34938) or (spellID == 34939) and nightfallEnabled) then  -- backlash proc
            LockNotes_MainDisplayFrameFontString:SetText("Incinerate!");
            LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0.5, 0);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
            spellHit = true;
        elseif (spellID == 47283) and nightfallEnabled then  -- empowered imp proc
            LockNotes_MainDisplayFrameFontString:SetText("Soul Fire!");
            LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0.5, 0);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
            spellHit = true;
        elseif ((spellID == 64371) or (spellID == 71165) or (spellID == 63167)) and eradicationEnabled then  -- eradication/molten core/decimation
			LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." up!");
            if (spellID == 64371) then
				LockNotes_MainDisplayFrameFontString:SetTextColor(0, 1, 0);
			else
				LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0.5, 0);
			end
            spellHit = true;
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bell.ogg");
        end
        if (spellHit) then -- if it registered and was caught, display the notice on the screen
    		if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                UIFrameFlashStop(LockNotes_MainDisplayFrame);
            end
        LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
            UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
        end
    end            
------------------------------------------------------------- Hostile Spells --------------------------------
elseif (eventType == "SPELL_CAST_SUCCESS") then
	if (meleeNoisesEnabled and 
        ((spellID == 6552) -- Pummel
     or (spellID == 96231) --  Rebuke
     or (spellID == 1766) --  Kick
     or (spellID == 80964) --  Skull Bash Bear (might not be needed, it's pretty loud already, but just for consistancy)
     or (spellID == 80965) --  Skull Bash Cat
     or (spellID == 47528))) then  --  Mind Freeze
		if (destName==UnitName("player")) then
			PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\gun_fire.ogg");	
		end
		
	elseif  bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 and enemyBuffsEnabled then -- Makes sure it's an enemy player    
		if  (spellID == 31224)    -- Cloak of Shadows
            or (spellID == 46924) -- Bladestorm
            or (spellID == 642)   -- Divine Shield
            or (spellID == 47585) -- Disperson
            or (spellID == 23920) -- Spell Reflect
            or (spellID == 48707) -- Anti Magic Shell
            or (spellID == 45438) -- IceBlock
            or (spellID == 19263) -- Deterrence
            or (spellID == 49039) -- LichBorne
            or (spellID == 18499) -- Berserker Rage
            or (spellID == 6346)  -- Fear Ward
            or (spellID == 1719)  -- Recklessness
            or (spellID == 96267)  -- Strength of Soul
            or (spellID == 8178 and targetAndFocusOnly) -- Grounding Totem
            or (spellID == 31821) then -- Concentration Aura
			local target = UnitGUID("target") -- aquire the player's target
			local focus = UnitGUID("focus")  -- aquire the player's focus
            if (targetAndFocusOnly and (sourceGUID==target or sourceGUID==focus)) then  -- if target and focus only is chosen and source is either target or focus
			    if (sourceGUID==target) then  -- if source is target then...
    				if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                        UIFrameFlashStop(LockNotes_MainDisplayFrame);
                    end
                    LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." up! (TAR)");
                    LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0, 0);
                    LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                    UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
				    if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
					elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) or (spellID == 46924) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
					else
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
					end
					if (spellID == 23920) then
					MySpellReflected = false;
					end
				elseif(sourceGUID==focus) then -- if source isn't target but is focus then...
					if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                        UIFrameFlashStop(LockNotes_MainDisplayFrame);
                    end
                    LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." up! (foc)");
                    LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0, 1);
                    LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                    UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
					if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
					elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
					else
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
					end
					if (spellID == 23920) then
					MySpellReflected = false;					
					end
				end
			elseif(not targetAndFocusOnly) then  -- if target and focus only isn't checkmarked, ready the spam
				if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
                end
                LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." up!");
                LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0, 0);
                LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
				if (spellID == 89485) or (spellID == 31821) then
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg"); -- Conc aura and inner focus, uninterruptable heals
				elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) then  -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
				else
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
				end
				if (spellID == 23920) then
				MySpellReflected = false;
				end				
			end
		end
	end

elseif (eventType == "SPELL_AURA_REMOVED") then
    if (LockNotes_FearCOTDown and sourceGUID==UnitGUID("player") and ((spellID==5782) or (spellID==6358))) then
        if(UIFrameIsFlashing(LockNotes_FearSeduceFrame)) then
            UIFrameFlashStop(LockNotes_FearSeduceFrame);
        end
        LockNotes_FearSeduceFrameFontString:SetText(spellName.." faded from "..LockNotes_StripServer(destName)..".");
        if(spellID==5782) then
            LockNotes_FearSeduceFrameFontString:SetTextColor(.5, 0, .5);
        else
            LockNotes_FearSeduceFrameFontString:SetTextColor(1, 0.5, 1)
        end
        UIFrameFlash(LockNotes_FearSeduceFrame, 0, 1, 3, false, 2, 0);
        PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\fearSeduceBreak.mp3");
	elseif (bit.band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0  and enemyBuffsEnabled) then
        local target = UnitGUID("target")
		local focus = UnitGUID("focus")
		if (spellID == 31224)    -- Cloak of Shadows
            or (spellID == 46924) -- Bladestorm
            or (spellID == 642)   -- Divine Shield
            or (spellID == 47585) -- Disperson
            or (spellID == 23920) -- Spell Reflect
            or (spellID == 48707) -- Anti Magic Shell
            or (spellID == 45438) -- IceBlock
            or (spellID == 19263) -- Deterrence
            or (spellID == 49039) -- LichBorne
            or (spellID == 18499) -- Berserker Rage
            or (spellID == 6346)  -- Fear Ward
            or (spellID == 1719)  -- Recklessness
            or (spellID == 96267)  -- Strength of Soul
            or (spellID == 8178) -- Grounding Totem
            or (spellID == 31821) then -- Concentration Aura
			if (targetAndFocusOnly and (target==sourceGUID or focus==sourceGUID)) then
                if(target==sourceGUID) then
                    LockNotes_MainDisplayFrameFontString:SetTextColor(0, 1, 0);
                    LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." down.");
                else
                    LockNotes_MainDisplayFrameFontString:SetTextColor(0.72, 0.53, 0.04);
                    LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." down.");
                end
                if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
                end
                LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
            elseif (not targetAndFocusOnly) then
				if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
                end
                LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." down.");
                LockNotes_MainDisplayFrameFontString:SetTextColor(0, 1, 0);
                LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
			end
        elseif (spellID == 23920) then
			if ((targetAndFocusOnly and (sourceGUID==target or sourceGUID==focus)) or (not targetAndFocusOnly)) then
				if (not MySpellReflected) then
					if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                        UIFrameFlashStop(LockNotes_MainDisplayFrame);
                    end
                    LockNotes_MainDisplayFrameFontString:SetText(""..spellName.." down.");
                    LockNotes_MainDisplayFrameFontString:SetTextColor(0, 1, 0);
                    LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
                    UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
				end
            end
		end
    elseif(LockNotes_SoulLinkAlert and sourceGUID==UnitGUID("pet") and spellID==25228 and (not IsFlying())) then ------ soul link
        local soulLinkFound = false;
        local i = 1;
        local buffNOTNil = 1;
        while (i <=40 and buffNOTNil) do local _,_,_,_,_,_,_,_,_,_,spellID=UnitBuff("pet",i);   
            i=i+1;
            buffNOTNil = spellID;
            if(spellID == 25228) then
                soulLinkFound = true;
            end
        end
        if(not soulLinkFound) then
            if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                UIFrameFlashStop(LockNotes_MainDisplayFrame);
            end
            LockNotes_MainDisplayFrameFontString:SetText("SOUL LINK DOWN");
            LockNotes_MainDisplayFrameFontString:SetTextColor(1, 1, 1);
            LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
            UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\klaxon.mp3");
        end
    end
   
------------------------------------------------------------- Dispel ----------------------------------------
elseif(eventType=="SPELL_DISPEL" and LNDispelTable["DispelEnabled"]) then
    local petGUID = UnitGUID("pet");
    if(sourceGUID==petGUID) then
		local spellLink = GetSpellLink(arg12);
		local chatMessage = ("Dispelled "..LockNotes_StripServer(destName).." ("..spellLink..")");
        if(LNDispelTable["DispelChatlog"]) then
            print(chatMessage);
        end
        if(LNDispelTable["DispelSay"]) then
            SendChatMessage(chatMessage,"say");
        end
        if(LNDispelTable["DispelParty"] and GetNumPartyMembers() > 0) then
            SendChatMessage(chatMessage,"party");
        end
        if(LNDispelTable["DispelRaid"] and GetRealNumRaidMembers() > 0) then
            SendChatMessage(chatMessage,"raid");
        end
        if(LNDispelTable["DispelBattleground"] and UnitInBattleground("player")) then
            SendChatMessage(chatMessage,"battleground");
        end
        if(LNDispelTable["DispelVisualAlert"]) then
            if  bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
                LockNotes_DispelSpellLockFrameFontString:SetTextColor(1, 1, 0); -- yellow
            else
                LockNotes_DispelSpellLockFrameFontString:SetTextColor(1, 1, 0); -- white
            end
            if(UIFrameIsFlashing(LockNotes_DispelSpellLockFrame)) then
                UIFrameFlashStop(LockNotes_DispelSpellLockFrame);
            end
            LockNotes_DispelSpellLockFrameFontString:SetText(chatMessage);
            LockNotes_DispelSpellLockFrameTexture:SetTexture(GetSpellTexture(arg12));
            UIFrameFlash(LockNotes_DispelSpellLockFrame, 0, 1, 3, false, 2, 0);
        end
    end
------------------------------------------------------------ Interrupt --------------------------------------
elseif(eventType=="SPELL_INTERRUPT" and LNSpelllockTable["SpelllockEnabled"]) then
    local petGUID = UnitGUID("pet");
    if(sourceGUID==petGUID) then
		local spellLink = GetSpellLink(arg12);
		local chatMessage = ("Interrupted "..LockNotes_StripServer(destName).." ("..spellLink..")");
        if(LNSpelllockTable["SpelllockChatlog"]) then
            print(chatMessage);
        end
        if(LNSpelllockTable["SpelllockSay"]) then
            SendChatMessage(chatMessage,"say");
        end
        if(LNSpelllockTable["SpelllockParty"] and GetNumPartyMembers() > 0) then
            SendChatMessage(chatMessage,"party");
        end
        if(LNSpelllockTable["SpelllockRaid"] and GetRealNumRaidMembers() > 0) then
            SendChatMessage(chatMessage,"raid");
        end
        if(LNSpelllockTable["SpelllockBattleground"] and UnitInBattleground("player")) then
            SendChatMessage(chatMessage,"battleground");
        end
        if(LNSpelllockTable["SpelllockVisualAlert"]) then
           if(UIFrameIsFlashing(LockNotes_DispelSpellLockFrame)) then
                UIFrameFlashStop(LockNotes_DispelSpellLockFrame);
            end
            LockNotes_DispelSpellLockFrameFontString:SetText(chatMessage);
            LockNotes_DispelSpellLockFrameFontString:SetTextColor(0, 1, 0);
            LockNotes_DispelSpellLockFrameTexture:SetTexture(GetSpellTexture(arg12));
            UIFrameFlash(LockNotes_DispelSpellLockFrame, 0, 1, 3, false, 2, 0);
        end                
    end
------------------------------------------------------------- Resists ---------------------------------------
elseif (resistsEnabled and eventType == "SPELL_MISSED") then -- need to add: evade, deflect (what is this?), check what happens when debuff is on an evading mob, dont want spam for each dot tick, even tho most evades remove all debuffs on them, not all
	if bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then -- Makes sure it's my own spell or my pet's spell
		if (spellID == 172) or (spellID == 6789) or (spellID == 1714) or (spellID == 702) or (spellID == 5782) or (spellID == 980) or (spellID == 689) or (spellID == 86213) or (spellID == 77799) then
            if (destName == "Grounding Totem") or (destName == "Тотем заземления") then
			    ResistMethod = "Grounded"
		    elseif (arg12 == "REFLECT") then
			    ResistMethod = "reflected"
			    MySpellReflected = true;
		    elseif (arg12 == "IMMUNE") then
    			ResistMethod = "failed (IMMUNE)"
            elseif (arg12 == "DEFLECT") then
                ResistMethod = "deflected"
    		else
	    		ResistMethod = "resisted"
    		end
	    	if (arg12 ~= "ABSORB") then
		        if(UIFrameIsFlashing(LockNotes_FearSeduceFrame)) then
                    UIFrameFlashStop(LockNotes_FearSeduceFrame);
                end
                LockNotes_FearSeduceFrameFontString:SetText(""..spellName.." "..ResistMethod..".");
                if(ResistMethod == "Grounded") then
                    LockNotes_FearSeduceFrameFontString:SetTextColor(.55, .27, .07);
                else
                LockNotes_FearSeduceFrameFontString:SetTextColor(1, 1, 1);
                end
                UIFrameFlash(LockNotes_FearSeduceFrame, 0, 1, 3, false, 2, 0);
		    	if (ResistMethod ~= "failed (IMMUNE)" and ResistMethod ~= "deflected") then -- only play sound file when you need to instantly recast what you just casted
			    	PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\cling.ogg");
			    end
		    end
        end
	end
---------------------------------------------------Unit Dies--------------------------------------
elseif (eventType == "UNIT_DIED" and LockNotes_DeathAnnounce) then
    if (bit.band(destFlags, COMBATLOG_OBJECT_CONTROL_PLAYER) > 0) then
        if(destGUID==UnitGUID("target")) then
            LockNotes_MainDisplayFrameFontString:SetTextColor(0, 1, 0);
            LockNotes_MainDisplayFrameFontString:SetText("TARGET IS DEAD!");
            if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
            end
            LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(14148));
            UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
            if(LockNotes_DeathAnnounceSounds)then
                PlaySoundFile("Sound\\Character\\PlayerExertions\\NightElfMaleFinal\\NightElfMaleMainDeath.ogg");
            end
        elseif(destGUID==UnitGUID("focus")) then
            LockNotes_MainDisplayFrameFontString:SetTextColor(1, 0, 1);
            LockNotes_MainDisplayFrameFontString:SetText("FOCUS IS DEAD!");
            if(UIFrameIsFlashing(LockNotes_MainDisplayFrame)) then
                    UIFrameFlashStop(LockNotes_MainDisplayFrame);
            end
            LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(14148));
            UIFrameFlash(LockNotes_MainDisplayFrame, 0, 1, 3, false, 2, 0);
            if(LockNotes_DeathAnnounceSounds) then
                PlaySoundFile("Sound\\Character\\PlayerExertions\\GnomeMaleFinal\\GnomeMaleMainWoundCrit.ogg");
            end
        end
   end
elseif (eventType == "SPELL_SUMMON") then
    if(sourceGUID == UnitGUID("player")) then
        LockNotes_PetChangeCount = 0;
------------------------------------------------------------ tremor ----------------------------------------
    elseif (destName == "Tremor Totem" and (bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0)) then
        LockNotes_TremorTotemID = destGUID;
        UIFrameFlash(LockNotes_TremorTotemFrame, 0, 0, 4, false, 4, 0);
        PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\tremornoise.ogg");
    end
    
elseif (eventType == "UNIT_DESTROYED" and destGUID == LockNotes_TremorTotemID) then
    UIFrameFlashStop(LockNotes_TremorTotemFrame);
end
------------------------------------------------------------------------------------------------------------------------------------------
end